Index: /TOOLS/MOSAIX/nemo.py
===================================================================
--- /TOOLS/MOSAIX/nemo.py	(revision 6665)
+++ /TOOLS/MOSAIX/nemo.py	(revision 6666)
@@ -539,351 +777,415 @@
     See NEMO documentation for further details
     '''
-    jpj, jpi = ptab.shape[-2:]
-    if nperio == None : nperio = __guessNperio__ (jpj, jpi, nperio)
-    
-    if nperio not in nperio_valid_range :
-        raise Exception ('nperio=', nperio, ' is not in the valid range', nperio_valid_range)
+    jpi, jpj = None, None
+    ax, ix = __find_axis__ (ptab, 'x')
+    ay, jy = __find_axis__ (ptab, 'y')
+    if ax :
+        jpi = ptab.shape[ix]
+    if ay :
+        jpj = ptab.shape[jy]
+
+    if nperio is None :
+        nperio = __guess_nperio__ (jpj, jpi, nperio)
+
+    if nperio not in NPERIO_VALID_RANGE :
+        raise AttributeError ( f'{nperio=} is not in the valid range {NPERIO_VALID_RANGE}' )
 
     return jpj, jpi, nperio
-        
-#@numba.jit(forceobj=True)
-def lbc (ptab, nperio=None, cd_type='T', psgn=1.0, nemo_4U_bug=False) :
-    '''
-    Set periodicity on input field
+
+def lbc (ptab, nperio=None, cd_type='T', psgn=1.0, nemo_4u_bug=False) :
+    '''Set periodicity on input field
+
     ptab      : Input array (works for rank 2 at least : ptab[...., lat, lon])
     nperio    : Type of periodicity
     cd_type   : Grid specification : T, U, V or F
     psgn      : For change of sign for vector components (1 for scalars, -1 for vector components)
-    
+
     See NEMO documentation for further details
     '''
-    jpj, jpi, nperio = lbc_init (ptab, nperio)
+    jpi, nperio = lbc_init (ptab, nperio)[1:]
+    ax = __find_axis__ (ptab, 'x')[0]
+    ay = __find_axis__ (ptab, 'y')[0]
     psgn   = ptab.dtype.type (psgn)
-    mmath = __mmath__ (ptab)
-    
-    if mmath == xr : ztab = ptab.values.copy ()
-    else           : ztab = ptab.copy ()
-        
-    #
-    #> East-West boundary conditions
-    # ------------------------------
-    if nperio in [1, 4, 6] :
+    mmath  = __mmath__ (ptab)
+
+    if mmath == xr :
+        ztab = ptab.values.copy ()
+    else           :
+        ztab = ptab.copy ()
+
+    if ax :
+        #
+        #> East-West boundary conditions
+        # ------------------------------
+        if nperio in [1, 4, 6] :
         # ... cyclic
-        ztab [..., :,  0] = ztab [..., :, -2]
-        ztab [..., :, -1] = ztab [..., :,  1]
-    #
-    #> North-South boundary conditions
-    # --------------------------------
-    if nperio in [3, 4] :  # North fold T-point pivot
-        if cd_type in [ 'T', 'W' ] : # T-, W-point
-            ztab [..., -1, 1:       ] = psgn * ztab [..., -3, -1:0:-1      ]
-            ztab [..., -1, 0        ] = psgn * ztab [..., -3, 2            ]
-            ztab [..., -2, jpi//2:  ] = psgn * ztab [..., -2, jpi//2:0:-1  ]
-                
-        if cd_type == 'U' :
-            ztab [..., -1, 0:-1     ] = psgn * ztab [..., -3, -1:0:-1      ]       
-            ztab [..., -1,  0       ] = psgn * ztab [..., -3,  1           ]
-            ztab [..., -1, -1       ] = psgn * ztab [..., -3, -2           ]
-                
-            if nemo_4U_bug :
-                ztab [..., -2, jpi//2+1:-1] = psgn * ztab [..., -2, jpi//2-2:0:-1]
-                ztab [..., -2, jpi//2-1   ] = psgn * ztab [..., -2, jpi//2       ]
-            else :
-                ztab [..., -2, jpi//2-1:-1] = psgn * ztab [..., -2, jpi//2:0:-1]
-                
-        if cd_type == 'V' : 
-            ztab [..., -2, 1:       ] = psgn * ztab [..., -3, jpi-1:0:-1   ]
-            ztab [..., -1, 1:       ] = psgn * ztab [..., -4, -1:0:-1      ]   
-            ztab [..., -1, 0        ] = psgn * ztab [..., -4, 2            ]
-                
-        if cd_type == 'F' :
-            ztab [..., -2, 0:-1     ] = psgn * ztab [..., -3, -1:0:-1      ]
-            ztab [..., -1, 0:-1     ] = psgn * ztab [..., -4, -1:0:-1      ]
-            ztab [..., -1,  0       ] = psgn * ztab [..., -4,  1           ]
-            ztab [..., -1, -1       ] = psgn * ztab [..., -4, -2           ]
-
-    if nperio in [4.2] :  # North fold T-point pivot
-        if cd_type in [ 'T', 'W' ] : # T-, W-point
-            ztab [..., -1, jpi//2:  ] = psgn * ztab [..., -1, jpi//2:0:-1  ]
-                
-        if cd_type == 'U' :
-            ztab [..., -1, jpi//2-1:-1] = psgn * ztab [..., -1, jpi//2:0:-1]
-                
-        if cd_type == 'V' : 
-            ztab [..., -1, 1:       ] = psgn * ztab [..., -2, jpi-1:0:-1   ]
-                
-        if cd_type == 'F' :
-            ztab [..., -1, 0:-1     ] = psgn * ztab [..., -2, -1:0:-1      ]
-
-    if nperio in [5, 6] :            #  North fold F-point pivot  
-        if cd_type in ['T', 'W']  :
-            ztab [..., -1, 0:       ] = psgn * ztab [..., -2, -1::-1       ]
-                
-        if cd_type == 'U' :
-            ztab [..., -1, 0:-1     ] = psgn * ztab [..., -2, -2::-1       ]       
-            ztab [..., -1, -1       ] = psgn * ztab [..., -2, 0            ] # Bug ?
-                
-        if cd_type == 'V' :
-            ztab [..., -1, 0:       ] = psgn * ztab [..., -3, -1::-1       ]
-            ztab [..., -2, jpi//2:  ] = psgn * ztab [..., -2, jpi//2-1::-1 ]
-                
-        if cd_type == 'F' :
-            ztab [..., -1, 0:-1     ] = psgn * ztab [..., -3, -2::-1       ]
-            ztab [..., -1, -1       ] = psgn * ztab [..., -3, 0            ]
-            ztab [..., -2, jpi//2:-1] = psgn * ztab [..., -2, jpi//2-2::-1 ]
-
-    #
-    #> East-West boundary conditions
-    # ------------------------------
-    if nperio in [1, 4, 6] :
-        # ... cyclic
-        ztab [..., :,  0] = ztab [..., :, -2]
-        ztab [..., :, -1] = ztab [..., :,  1]
+            ztab [...,  0] = ztab [..., -2]
+            ztab [..., -1] = ztab [...,  1]
+
+        if ay :
+            #
+            #> North-South boundary conditions
+            # --------------------------------
+            if nperio in [3, 4] :  # North fold T-point pivot
+                if cd_type in [ 'T', 'W' ] : # T-, W-point
+                    ztab [..., -1, 1:       ] = psgn * ztab [..., -3, -1:0:-1      ]
+                    ztab [..., -1, 0        ] = psgn * ztab [..., -3, 2            ]
+                    ztab [..., -2, jpi//2:  ] = psgn * ztab [..., -2, jpi//2:0:-1  ]
+
+                if cd_type == 'U' :
+                    ztab [..., -1, 0:-1     ] = psgn * ztab [..., -3, -1:0:-1      ]
+                    ztab [..., -1,  0       ] = psgn * ztab [..., -3,  1           ]
+                    ztab [..., -1, -1       ] = psgn * ztab [..., -3, -2           ]
+
+                    if nemo_4u_bug :
+                        ztab [..., -2, jpi//2+1:-1] = psgn * ztab [..., -2, jpi//2-2:0:-1]
+                        ztab [..., -2, jpi//2-1   ] = psgn * ztab [..., -2, jpi//2       ]
+                    else :
+                        ztab [..., -2, jpi//2-1:-1] = psgn * ztab [..., -2, jpi//2:0:-1]
+
+                if cd_type == 'V' :
+                    ztab [..., -2, 1:       ] = psgn * ztab [..., -3, jpi-1:0:-1   ]
+                    ztab [..., -1, 1:       ] = psgn * ztab [..., -4, -1:0:-1      ]
+                    ztab [..., -1, 0        ] = psgn * ztab [..., -4, 2            ]
+
+                if cd_type == 'F' :
+                    ztab [..., -2, 0:-1     ] = psgn * ztab [..., -3, -1:0:-1      ]
+                    ztab [..., -1, 0:-1     ] = psgn * ztab [..., -4, -1:0:-1      ]
+                    ztab [..., -1,  0       ] = psgn * ztab [..., -4,  1           ]
+                    ztab [..., -1, -1       ] = psgn * ztab [..., -4, -2           ]
+
+            if nperio in [4.2] :  # North fold T-point pivot
+                if cd_type in [ 'T', 'W' ] : # T-, W-point
+                    ztab [..., -1, jpi//2:  ] = psgn * ztab [..., -1, jpi//2:0:-1  ]
+
+                if cd_type == 'U' :
+                    ztab [..., -1, jpi//2-1:-1] = psgn * ztab [..., -1, jpi//2:0:-1]
+
+                if cd_type == 'V' :
+                    ztab [..., -1, 1:       ] = psgn * ztab [..., -2, jpi-1:0:-1   ]
+
+                if cd_type == 'F' :
+                    ztab [..., -1, 0:-1     ] = psgn * ztab [..., -2, -1:0:-1      ]
+
+            if nperio in [5, 6] :            #  North fold F-point pivot
+                if cd_type in ['T', 'W']  :
+                    ztab [..., -1, 0:       ] = psgn * ztab [..., -2, -1::-1       ]
+
+                if cd_type == 'U' :
+                    ztab [..., -1, 0:-1     ] = psgn * ztab [..., -2, -2::-1       ]
+                    ztab [..., -1, -1       ] = psgn * ztab [..., -2, 0            ] # Bug ?
+
+                if cd_type == 'V' :
+                    ztab [..., -1, 0:       ] = psgn * ztab [..., -3, -1::-1       ]
+                    ztab [..., -2, jpi//2:  ] = psgn * ztab [..., -2, jpi//2-1::-1 ]
+
+                if cd_type == 'F' :
+                    ztab [..., -1, 0:-1     ] = psgn * ztab [..., -3, -2::-1       ]
+                    ztab [..., -1, -1       ] = psgn * ztab [..., -3, 0            ]
+                    ztab [..., -2, jpi//2:-1] = psgn * ztab [..., -2, jpi//2-2::-1 ]
+
+            #
+            #> East-West boundary conditions
+            # ------------------------------
+            if nperio in [1, 4, 6] :
+                # ... cyclic
+                ztab [...,  0] = ztab [..., -2]
+                ztab [..., -1] = ztab [...,  1]
 
     if mmath == xr :
-        ztab = xr.DataArray ( ztab, dims=ptab.dims, coords=ptab.coords)
+        ztab = xr.DataArray ( ztab, dims=ptab.dims, coords=ptab.coords )
         ztab.attrs = ptab.attrs
-        
+
     return ztab
 
-#@numba.jit(forceobj=True)
 def lbc_mask (ptab, nperio=None, cd_type='T', sval=np.nan) :
-    #
-    '''
-    Mask fields on duplicated points
+    '''Mask fields on duplicated points
+
     ptab      : Input array. Rank 2 at least : ptab [...., lat, lon]
     nperio    : Type of periodicity
     cd_type   : Grid specification : T, U, V or F
-    
+
     See NEMO documentation for further details
     '''
-    jpj, jpi, nperio = lbc_init (ptab, nperio)
+    jpi, nperio = lbc_init (ptab, nperio)[1:]
+    ax = __find_axis__ (ptab, 'x')[0]
+    ay = __find_axis__ (ptab, 'y')[0]
     ztab = ptab.copy ()
 
-    #
-    #> East-West boundary conditions
-    # ------------------------------
-    if nperio in [1, 4, 6] :
+    if ax :
+        #
+        #> East-West boundary conditions
+        # ------------------------------
+        if nperio in [1, 4, 6] :
         # ... cyclic
-        ztab [..., :,  0] = sval
-        ztab [..., :, -1] = sval
-
-    #
-    #> South (in which nperio cases ?)
-    # --------------------------------
-    if nperio in [1, 3, 4, 5, 6] :
-        ztab [..., 0, :] = sval
-        
-    #
-    #> North-South boundary conditions
-    # --------------------------------
-    if nperio in [3, 4] :  # North fold T-point pivot
-        if cd_type in [ 'T', 'W' ] : # T-, W-point
-            ztab [..., -1,  :         ] = sval
-            ztab [..., -2, :jpi//2  ] = sval
-                
-        if cd_type == 'U' :
-            ztab [..., -1,  :         ] = sval  
-            ztab [..., -2, jpi//2+1:  ] = sval
-                
-        if cd_type == 'V' :
-            ztab [..., -2, :       ] = sval
-            ztab [..., -1, :       ] = sval   
-                
-        if cd_type == 'F' :
-            ztab [..., -2, :       ] = sval
-            ztab [..., -1, :       ] = sval
-
-    if nperio in [4.2] :  # North fold T-point pivot
-        if cd_type in [ 'T', 'W' ] : # T-, W-point
-            ztab [..., -1, jpi//2  :  ] = sval
-                
-        if cd_type == 'U' :
-            ztab [..., -1, jpi//2-1:-1] = sval
-                
-        if cd_type == 'V' : 
-            ztab [..., -1, 1:       ] = sval
-                
-        if cd_type == 'F' :
-            ztab [..., -1, 0:-1     ] = sval
-    
-    if nperio in [5, 6] :            #  North fold F-point pivot
-        if cd_type in ['T', 'W']  :
-            ztab [..., -1, 0:       ] = sval
-                
-        if cd_type == 'U' :
-            ztab [..., -1, 0:-1     ] = sval       
-            ztab [..., -1, -1       ] = sval
-             
-        if cd_type == 'V' :
-            ztab [..., -1, 0:       ] = sval
-            ztab [..., -2, jpi//2:  ] = sval
-                             
-        if cd_type == 'F' :
-            ztab [..., -1, 0:-1       ] = sval
-            ztab [..., -1, -1         ] = sval
-            ztab [..., -2, jpi//2+1:-1] = sval
+            ztab [...,  0] = sval
+            ztab [..., -1] = sval
+
+        if ay :
+            #
+            #> South (in which nperio cases ?)
+            # --------------------------------
+            if nperio in [1, 3, 4, 5, 6] :
+                ztab [..., 0, :] = sval
+
+            #
+            #> North-South boundary conditions
+            # --------------------------------
+            if nperio in [3, 4] :  # North fold T-point pivot
+                if cd_type in [ 'T', 'W' ] : # T-, W-point
+                    ztab [..., -1,  :         ] = sval
+                    ztab [..., -2, :jpi//2  ] = sval
+
+                if cd_type == 'U' :
+                    ztab [..., -1,  :         ] = sval
+                    ztab [..., -2, jpi//2+1:  ] = sval
+
+                if cd_type == 'V' :
+                    ztab [..., -2, :       ] = sval
+                    ztab [..., -1, :       ] = sval
+
+                if cd_type == 'F' :
+                    ztab [..., -2, :       ] = sval
+                    ztab [..., -1, :       ] = sval
+
+            if nperio in [4.2] :  # North fold T-point pivot
+                if cd_type in [ 'T', 'W' ] : # T-, W-point
+                    ztab [..., -1, jpi//2  :  ] = sval
+
+                if cd_type == 'U' :
+                    ztab [..., -1, jpi//2-1:-1] = sval
+
+                if cd_type == 'V' :
+                    ztab [..., -1, 1:       ] = sval
+
+                if cd_type == 'F' :
+                    ztab [..., -1, 0:-1     ] = sval
+
+            if nperio in [5, 6] :            #  North fold F-point pivot
+                if cd_type in ['T', 'W']  :
+                    ztab [..., -1, 0:       ] = sval
+
+                if cd_type == 'U' :
+                    ztab [..., -1, 0:-1     ] = sval
+                    ztab [..., -1, -1       ] = sval
+
+                if cd_type == 'V' :
+                    ztab [..., -1, 0:       ] = sval
+                    ztab [..., -2, jpi//2:  ] = sval
+
+                if cd_type == 'F' :
+                    ztab [..., -1, 0:-1       ] = sval
+                    ztab [..., -1, -1         ] = sval
+                    ztab [..., -2, jpi//2+1:-1] = sval
 
     return ztab
 
-#@numba.jit(forceobj=True)
 def lbc_plot (ptab, nperio=None, cd_type='T', psgn=1.0, sval=np.nan) :
-    '''
-    Set periodicity on input field, adapted for plotting for any cartopy projection
+    '''Set periodicity on input field, for plotting for any cartopy projection
+
+      Points at the north fold are masked
+      Points for zonal periodicity are kept
     ptab      : Input array. Rank 2 at least : ptab[...., lat, lon]
     nperio    : Type of periodicity
     cd_type   : Grid specification : T, U, V or F
-    psgn      : For change of sign for vector components (1 for scalars, -1 for vector components)
-    
+    psgn      : For change of sign for vector components
+           (1 for scalars, -1 for vector components)
+
     See NEMO documentation for further details
     '''
-
-    jpj, jpi, nperio = lbc_init (ptab, nperio)
+    jpi, nperio = lbc_init (ptab, nperio)[1:]
+    ax = __find_axis__ (ptab, 'x')[0]
+    ay = __find_axis__ (ptab, 'y')[0]
     psgn   = ptab.dtype.type (psgn)
     ztab   = ptab.copy ()
-    #
-    #> East-West boundary conditions
-    # ------------------------------
-    if nperio in [1, 4, 6] :
-        # ... cyclic
-        ztab [..., :,  0] = ztab [..., :, -2]
-        ztab [..., :, -1] = ztab [..., :,  1]
-
-    #> Masks south
-    # ------------
-    if nperio in [4, 6] : ztab [..., 0, : ] = sval
-        
-    #
-    #> North-South boundary conditions
-    # --------------------------------
-    if nperio in [3, 4] :  # North fold T-point pivot
-        if cd_type in [ 'T', 'W' ] : # T-, W-point
-            ztab [..., -1,  :      ] = sval
-            #ztab [..., -2, jpi//2: ] = sval
-            ztab [..., -2, :jpi//2 ] = sval # Give better plots than above
-        if cd_type == 'U' :
-            ztab [..., -1, : ] = sval
-
-        if cd_type == 'V' : 
-            ztab [..., -2, : ] = sval
-            ztab [..., -1, : ] = sval
-            
-        if cd_type == 'F' :
-            ztab [..., -2, : ] = sval
-            ztab [..., -1, : ] = sval
-
-    if nperio in [4.2] :  # North fold T-point pivot
-        if cd_type in [ 'T', 'W' ] : # T-, W-point
-            ztab [..., -1, jpi//2:  ] = sval
-                
-        if cd_type == 'U' :
-            ztab [..., -1, jpi//2-1:-1] = sval
-                
-        if cd_type == 'V' : 
-            ztab [..., -1, 1:       ] = sval
-                
-        if cd_type == 'F' :
-            ztab [..., -1, 0:-1     ] = sval
-      
-    if nperio in [5, 6] :            #  North fold F-point pivot  
-        if cd_type in ['T', 'W']  :
-            ztab [..., -1, : ] = sval
-                
-        if cd_type == 'U' :
-            ztab [..., -1, : ] = sval      
-             
-        if cd_type == 'V' :
-            ztab [..., -1, :        ] = sval
-            ztab [..., -2, jpi//2:  ] = sval
-                             
-        if cd_type == 'F' :
-            ztab [..., -1, :          ] = sval
-            ztab [..., -2, jpi//2+1:-1] = sval
+
+    if ax :
+        #
+        #> East-West boundary conditions
+        # ------------------------------
+        if nperio in [1, 4, 6] :
+            # ... cyclic
+            ztab [..., :,  0] = ztab [..., :, -2]
+            ztab [..., :, -1] = ztab [..., :,  1]
+
+        if ay :
+            #> Masks south
+            # ------------
+            if nperio in [4, 6] :
+                ztab [..., 0, : ] = sval
+
+            #
+            #> North-South boundary conditions
+            # --------------------------------
+            if nperio in [3, 4] :  # North fold T-point pivot
+                if cd_type in [ 'T', 'W' ] : # T-, W-point
+                    ztab [..., -1,  :      ] = sval
+                    #ztab [..., -2, jpi//2: ] = sval
+                    ztab [..., -2, :jpi//2 ] = sval # Give better plots than above
+                if cd_type == 'U' :
+                    ztab [..., -1, : ] = sval
+
+                if cd_type == 'V' :
+                    ztab [..., -2, : ] = sval
+                    ztab [..., -1, : ] = sval
+
+                if cd_type == 'F' :
+                    ztab [..., -2, : ] = sval
+                    ztab [..., -1, : ] = sval
+
+            if nperio in [4.2] :  # North fold T-point pivot
+                if cd_type in [ 'T', 'W' ] : # T-, W-point
+                    ztab [..., -1, jpi//2:  ] = sval
+
+                if cd_type == 'U' :
+                    ztab [..., -1, jpi//2-1:-1] = sval
+
+                if cd_type == 'V' :
+                    ztab [..., -1, 1:       ] = sval
+
+                if cd_type == 'F' :
+                    ztab [..., -1, 0:-1     ] = sval
+
+            if nperio in [5, 6] :            #  North fold F-point pivot
+                if cd_type in ['T', 'W']  :
+                    ztab [..., -1, : ] = sval
+
+                if cd_type == 'U' :
+                    ztab [..., -1, : ] = sval
+
+                if cd_type == 'V' :
+                    ztab [..., -1, :        ] = sval
+                    ztab [..., -2, jpi//2:  ] = sval
+
+                if cd_type == 'F' :
+                    ztab [..., -1, :          ] = sval
+                    ztab [..., -2, jpi//2+1:-1] = sval
 
     return ztab
 
-#@numba.jit(forceobj=True)
-def lbc_add (ptab, nperio=None, cd_type=None, psgn=1, sval=None) :
-    '''
-    Handle NEMO domain changes between NEMO 4.0 to NEMO 4.2
-      Peridodicity halo has been removed
+def lbc_add (ptab, nperio=None, cd_type=None, psgn=1) :
+    '''Handles NEMO domain changes between NEMO 4.0 to NEMO 4.2
+
+    Periodicity and north fold halos has been removed in NEMO 4.2
     This routine adds the halos if needed
 
-    ptab      : Input array (works 
+    ptab      : Input array (works
       rank 2 at least : ptab[...., lat, lon]
     nperio    : Type of periodicity
- 
+
     See NEMO documentation for further details
     '''
-    mmath = __mmath__ (ptab) 
-    jpj, jpi, nperio = lbc_init (ptab, nperio)
+    mmath = __mmath__ (ptab)
+    nperio = lbc_init (ptab, nperio)[-1]
+    lshape = get_shape (ptab)
+    ix = __find_axis__ (ptab, 'x')[-1]
+    jy = __find_axis__ (ptab, 'y')[-1]
 
     t_shape = np.array (ptab.shape)
 
-    if nperio == 4.2 or nperio == 6.2 :
-      
-        ext_shape = t_shape
-        ext_shape[-1] = ext_shape[-1] + 2
-        ext_shape[-2] = ext_shape[-2] + 1
+    if nperio in [4.2, 6.2] :
+
+        ext_shape = t_shape.copy()
+        if 'X' in lshape :
+            ext_shape[ix] = ext_shape[ix] + 2
+        if 'Y' in lshape :
+            ext_shape[jy] = ext_shape[jy] + 1
 
         if mmath == xr :
-            ptab_ext = xr.DataArray (np.zeros (ext_shape), dims=ptab.dims) 
-            ptab_ext.values[..., :-1, 1:-1] = ptab.values.copy ()
+            ptab_ext = xr.DataArray (np.zeros (ext_shape), dims=ptab.dims)
+            if 'X' in lshape and 'Y' in lshape :
+                ptab_ext.values[..., :-1, 1:-1] = ptab.values.copy ()
+            else :
+                if 'X' in lshape     :
+                    ptab_ext.values[...,      1:-1] = ptab.values.copy ()
+                if 'Y' in lshape     :
+                    ptab_ext.values[..., :-1      ] = ptab.values.copy ()
         else           :
             ptab_ext =               np.zeros (ext_shape)
-            ptab_ext[..., :-1, 1:-1] = ptab.copy ()
-            
-        #if sval != None :  ptab_ext[..., 0, :] = sval
-        
-        if nperio == 4.2 : ptab_ext = lbc (ptab_ext, nperio=4, cd_type=cd_type, psgn=psgn)
-        if nperio == 6.2 : ptab_ext = lbc (ptab_ext, nperio=6, cd_type=cd_type, psgn=psgn)
-             
+            if 'X' in lshape and 'Y' in lshape :
+                ptab_ext       [..., :-1, 1:-1] = ptab.copy ()
+            else :
+                if 'X' in lshape     :
+                    ptab_ext       [...,      1:-1] = ptab.copy ()
+                if 'Y' in lshape     :
+                    ptab_ext       [..., :-1      ] = ptab.copy ()
+
+        if nperio == 4.2 :
+            ptab_ext = lbc (ptab_ext, nperio=4, cd_type=cd_type, psgn=psgn)
+        if nperio == 6.2 :
+            ptab_ext = lbc (ptab_ext, nperio=6, cd_type=cd_type, psgn=psgn)
+
         if mmath == xr :
             ptab_ext.attrs = ptab.attrs
+            az = __find_axis__ (ptab, 'z')[0]
+            at = __find_axis__ (ptab, 't')[0]
+            if az :
+                ptab_ext = ptab_ext.assign_coords ( {az:ptab.coords[az]} )
+            if at :
+                ptab_ext = ptab_ext.assign_coords ( {at:ptab.coords[at]} )
 
     else : ptab_ext = lbc (ptab, nperio=nperio, cd_type=cd_type, psgn=psgn)
-        
+
     return ptab_ext
 
 def lbc_del (ptab, nperio=None, cd_type='T', psgn=1) :
-    '''
-    Handle NEMO domain changes between NEMO 4.0 to NEMO 4.2
-      Periodicity halo has been removed
+    '''Handles NEMO domain changes between NEMO 4.0 to NEMO 4.2
+
+    Periodicity and north fold halos has been removed in NEMO 4.2
     This routine removes the halos if needed
 
-    ptab      : Input array (works 
+    ptab      : Input array (works
       rank 2 at least : ptab[...., lat, lon]
     nperio    : Type of periodicity
- 
+
     See NEMO documentation for further details
     '''
-
-    jpj, jpi, nperio = lbc_init (ptab, nperio)
-
-    if nperio == 4.2 or nperio == 6.2 :
-        return lbc (ptab[..., :-1, 1:-1], nperio=nperio, cd_type=cd_type, psgn=psgn)
-    else :
-        return ptab
-
-#@numba.jit(forceobj=True)
+    nperio = lbc_init (ptab, nperio)[-1]
+    #lshape = get_shape (ptab)
+    ax = __find_axis__ (ptab, 'x')[0]
+    ay = __find_axis__ (ptab, 'y')[0]
+
+    if nperio in [4.2, 6.2] :
+        if ax or ay :
+            if ax and ay :
+                ztab = lbc (ptab[..., :-1, 1:-1],
+                            nperio=nperio, cd_type=cd_type, psgn=psgn)
+            else :
+                if ax :
+                    ztab = lbc (ptab[...,      1:-1],
+                                nperio=nperio, cd_type=cd_type, psgn=psgn)
+                if ay :
+                    ztab = lbc (ptab[..., -1],
+                                nperio=nperio, cd_type=cd_type, psgn=psgn)
+        else :
+            ztab = ptab
+    else :
+        ztab = ptab
+
+    return ztab
+
 def lbc_index (jj, ii, jpj, jpi, nperio=None, cd_type='T') :
-    '''
-    For indexes of a NEMO point, give the corresponding point inside the util domain
+    '''For indexes of a NEMO point, give the corresponding point
+        inside the domain (i.e. not in the halo)
+
     jj, ii    : indexes
     jpi, jpi  : size of domain
     nperio    : type of periodicity
     cd_type   : grid specification : T, U, V or F
-    
+
     See NEMO documentation for further details
     '''
 
-    if nperio == None : nperio = __guessNperio__ (jpj, jpi, nperio)
-    
-    ## For the sake of simplicity, switch to the convention of original lbc Fortran routine from NEMO
-    ## : starts indexes at 1
-    jy = jj + 1 ; ix = ii + 1
+    if nperio is None :
+        nperio = __guess_nperio__ (jpj, jpi, nperio)
+
+    ## For the sake of simplicity, switch to the convention of original
+    ## lbc Fortran routine from NEMO : starts indexes at 1
+    jy = jj + 1
+    ix = ii + 1
 
     mmath = __mmath__ (jj)
-    if mmath == None : mmath=np
+    if mmath is None :
+        mmath=np
 
     #
@@ -896,5 +1198,5 @@
 
     #
-    def modIJ (cond, jy_new, ix_new) :
+    def mod_ij (cond, jy_new, ix_new) :
         jy_r = mmath.where (cond, jy_new, jy)
         ix_r = mmath.where (cond, ix_new, ix)
